import es, playerlib, gamethread, random, usermsg, os.path

# The only optiosn that are in here are dictionary options that I'm too lazy to make for server vars but will be eventually
### Dict Options ###
messages = {
	0: 'The Zombies Are Weak, But You Are Weaker',
	1: 'I\'m Too Young To Die',
	2: 'Hey Not Too Rough',
	3: 'Hurt Me Plenty',
	4: 'UltraViolence',
	5: 'Nightmare',
	6: 'You Win!'
}

ammo = {
	'ammo_338mag_max': 666,
	'ammo_357sig_max': 666,
	'ammo_45acp_max': 666,
	'ammo_50AE_max': 666,
	'ammo_556mm_box_max': 666,
	'ammo_556mm_max': 666,
	'ammo_57mm_max': 666,
	'ammo_762mm_max': 666,
	'ammo_9mm_max': 666,
	'ammo_buckshot_max': 666
}
#### No Config Below ###

temp_zombies = 0
wins = 0

info = es.AddonInfo() 
info['name']        = "Zombie Hell 2.0" 
info['version']     = "1.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/zombiehell2" 
info['description'] = "A python version of ZombieHell requested by Undead for better speed + performance" 

es.ServerVar('zh2_version', info['version'], 'ZombieHell 2.0 made by Bonbon AKA Bonbon367').makepublic()

sv = es.ServerVar

sv_options = {
	'zombie_health_min': 200,
	'zombie_health_max': 300,
	'zombie_health_level_bonus_multiplier': 3,
	'zombie_speed_min': 0.8,
	'zombie_speed_max': 1.2,
	'zombie_speed_level_bonus_multiplier': 0.01,
	'zombie_armor_min': 50,
	'zombie_armor_max': 100,
	'zombie_armor_level_bonus_multiplier': 2,
	'boss_chance': 10,
	'boss_model': 'humans/corpse1',
	'boss_health_min': 1000,
	'boss_health_max': 3333,
	'boss_speed_min': 1,
	'boss_speed_max': 1.75,
	'boss_armor_min': 1000,
	'boss_armor_max': 3333,
	'zombie_fog': 1,
	'zombie_fog_rgb': '100,100,100',
	'zombie_fog_rgb2': '150,150,150',
	'zombie_models': 'zombie/classic,zombie/fast,zombie/poison,humans/charple01,humans/charple02,humans/charple03,humans/charple04',
	'restricted_weapons': 'm249,g3sg1,sg550,awp,flashbang,smokegrenade',
	'dissolve_on_death': 1,
	'stock_zombies': 3,
	'stock_multiplier': 3,
	'downloads': '',
	'rounds_to_win': 5,
	'hud_update_time': 7,
	'start_cash': 16000,
	'zombie_bots': 10,
	'enable_knockback': 1,
	'zombie_knockback_min': 5,
	'zombie_knockback_max': 10,
	'boss_knockback_min': 3,
	'boss_knockback_max': 6,
	'zombie_knockback_level_multiplier_minus': 1,
	'fog_start': 100,
	'fog_end': 750
}

def load():
	add_downloads()
	fog_start()
	for type in ammo:
		es.server.queuecmd('%s %s'%(type, ammo[type]))
	knife_bot()
	add_bots()
	for a in sv_options:
		es.ServerVar(a).set(sv_options[a])
	if os.path.isfile(es.getAddonPath('zombiehell') + '/zombiehell.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/zombiehell/zombiehell.cfg')
	else:
		es.dbgmsg(0, 'Config not found')

def unload():
	if es.getuserid():
		es.server.queuecmd('es_xfire %s env_fog_controller kill'%es.getuserid())
	for loop in ['update_hud']:
		gamethread.cancelDelayed(loop)
	kick_bots()

#### Events ###

def player_spawn(ev):
	userid = ev['userid']
	Player(userid).set_attributes()
	Player(ev['userid']).check_team()

def player_death(ev):
	userid = ev['userid']
	if int(sv('dissolve_on_death')):
		Player(userid).dissolve()
	Player(userid).check_respawn()
	Player(userid).play_sound()

def es_map_start(ev):
	global wins
	wins = 0
	fog_start()
	add_downloads()
	knife_bot()

def item_pickup(ev):
	Player(ev['userid']).check_restrict(ev['item'])
	if ev['item'] == 'c4': es.server.queuecmd('es_xfire %s weapon_c4 kill'%ev['userid'])

def player_hurt(ev):
	Player(ev['attacker']).check_restrict(ev['weapon'])
	Player(ev['userid']).knockback(ev['attacker'], int(ev['dmg_health']))
	if not random.randint(0, 6):
		Player(ev['userid']).play_sound()

def round_start(ev):
	global temp_zombies
	temp_zombies = len(playerlib.getUseridList('#human')) * int(sv('stock_zombies')) + int(wins * float(sv('stock_multiplier')))

def round_freeze_end(ev):
	if 0 < wins < int(sv('rounds_to_win')):
		es.msg('#multi', '#lightgreenWARNING: #defaultQuarantine in level #lightgreen%s#default has been breeched! KILL ON SIGHT!'%wins)
	elif wins == int(sv('rounds_to_win')):
		for userid in es.getUseridList():
			usermsg.shake(userid, 50, 4.5)
		es.msg('#multi', '#lightgreenWARNING: #default Quarantine in level #lightgreen%s#default has been breeched! ZOMBIES HAVE EVOLVED!'%wins)
	else:
		global wins
		wins = 0

def round_end(ev):
	global wins
	if es.getUseridList() > 2:
		wins = max(0, wins + (1 if not len(playerlib.getUseridList('#bot,#alive')) else -1))
		if wins > int(sv('rounds_to_win')):
			es.msg('#multi', '#defaultCongratulations on defeating all the zombies, The game will end in #lightgreen5#default seconds')
			gamethread.delayed(5, es.server.queuecmd, 'es_entcreate %s game_end;es_fire %s game_end endgame'%(es.getuserid(), es.getuserid()))
	else:
		es.msg('Not enough players to start')

def player_team(ev):
	Player(ev['userid']).check_team()

### Classes ###

class Player:
	def __init__(self, userid):
		self.userid = userid
		self.steamid = es.getplayersteamid(userid)

	def dissolve(self):
		if not playerlib.getPlayer(self.userid).get('isdead'):
			playerlib.getPlayer(self.userid).set('health', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%self.userid)
		es.server.queuecmd('es_give %s env_entity_dissolver'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "magnitude 1"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "dissolvetype %s"'%(self.userid, random.randint(0, 3)))
		es.server.queuecmd('es_xfire %s env_entity_dissolver Dissolve'%self.userid)
		gamethread.delayed(1, es.server.queuecmd, 'es_xfire %s env_entity_dissolver kill'%self.userid)

	def check_restrict(self, weapon):
		if self.steamid == 'BOT' and not 'knife' in weapon:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%self.userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip StripWeaponsAndSuit'%self.userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%self.userid)
		elif weapon.replace('weapon_', '') in str(sv('restricted_weapons')):
			for index in es.createentitylist('weapon_%s'%weapon.replace('weapon_', '')):
				if int(es.getplayerhandle(self.userid)) == int(es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")):
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(self.userid, '#multi', '#greenSorry, the #lightgreen%s #greenis restricted'%(weapon.replace('weapon_', '')))

	def check_respawn(self):
		if self.steamid == 'BOT':
			if temp_zombies > 0:
				global temp_zombies
				temp_zombies -= 1
				es.server.queuecmd('est_spawn %s'%self.userid)

	def set_attributes(self):
		if self.steamid == 'BOT':
			if random.randint(1, 100) > float(sv('boss_chance')) or wins < int(sv('rounds_to_win')):
				playerlib.getPlayer(self.userid).set('model', random.choice(str(sv('zombie_models')).split(',')))
				playerlib.getPlayer(self.userid).set('health', random_value(int(sv('zombie_health_min')), int(sv('zombie_health_max')) + (wins * float(sv('zombie_health_level_bonus_multiplier')))))
				playerlib.getPlayer(self.userid).set('speed', random_value(float(sv('zombie_speed_min')), float(sv('zombie_speed_max'))) + (wins * float(sv('zombie_speed_level_bonus_multiplier'))))
				playerlib.getPlayer(self.userid).set('armor', random_value(int(sv('zombie_armor_min')), int(sv('zombie_armor_max'))) + (wins * float(sv('zombie_armor_level_bonus_multiplier'))))
			else:
				playerlib.getPlayer(self.userid).set('model', str(sv('boss_model')))
				playerlib.getPlayer(self.userid).set('health', random_value(float(sv('boss_health_min')), int(sv('boss_health_max'))))
				playerlib.getPlayer(self.userid).set('speed', random_value(float(sv('boss_speed_min')), float(sv('boss_speed_max'))))
				playerlib.getPlayer(self.userid).set('armor', random_value(int(sv('boss_armor_min')), int(sv('boss_armor_max'))))
			playerlib.getPlayer(self.userid).set('cash', 0)
		else:
			if int(sv('start_cash')):
				playerlib.getPlayer(self.userid).set('cash', int(sv('start_cash')))

	def hud(self):
		humans = 0
		zombies = 0
		for userid in playerlib.getUseridList('#human,#alive'):
			humans += 1
		for userid in playerlib.getUseridList('#bot,#alive'):
			zombies += 1
		usermsg.hudhint(self.userid, '!!! Zombie Hell !!!\nHumans: %s\nZombies: %s\nDifficulty: %s\nReserve: %s'%(humans, zombies, messages[wins], temp_zombies))

	def play_sound(self):
		if self.steamid == 'BOT':
			sounds = []
			for a in range(1, 10):
				if a < 5:
					sounds.append('npc/zombie/moan_loop' + str(a))
				if a < 4:
					sounds.append('npc/zombie/zombie_die' + str(a))
					sounds.append('npc/zombie/zombie_alert' + str(a))
				if sounds < 7:
					sounds.append('npc/zombie/zombie_pain' + str(a))
				sounds.append('npc/zombie/zombie_voice_idle' + str(a))
			sound = random.choice(sounds)
			es.emitsound('player', self.userid, sound + '.wav', 0.75, 0.4)
			gamethread.delayed(3, es.stopsound, (self.userid, sound + '.wav'))

	def check_team(self):
		if es.exists('userid', self.userid):
			if self.steamid == 'BOT':
				if not playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 2'%self.userid)
			else:
				if playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 3'%self.userid)
					es.tell(self.userid, '#multi', '#lightgreen[Zombie Hell]: #defaultHumans can only be on the #lightgreenTerrorists')

	def knockback(self, attacker, damage):
		if self.steamid == 'BOT':
			if int(sv('enable_knockback')):
				knockback = random_value(float(sv('zombie_knockback_min')) if wins < int(sv('rounds_to_win')) else float(sv('boss_knockback_min')), float(sv('zombie_knockback_max')) if wins < int(sv('rounds_to_win')) else float(sv('boss_knockback_max')))
				knockback *= int(damage)
				knockback -= float(sv('zombie_knockback_level_multiplier_minus')) * wins if wins < int(sv('rounds_to_win')) else 0
				if int(attacker) and not int(self.userid) == int(attacker):
					x, y, z = playerlib.getPlayer(attacker).get('viewvector')
					playerlib.getPlayer(self.userid).set('push', [x * knockback, y * knockback, 0])

### Functions ###

def add_downloads():
	for a in str(sv('downloadables')).split(','):
		es.stringtable('downloadables', a)

def fog_start():
	if int(sv('zombie_fog')):
		userid = es.getuserid()
		r, g, b = str(sv('zombie_fog_rgb')).split(',')
		r2, g2, b2 = str(sv('zombie_fog_rgb2')).split(',')
		if userid:
			es.server.queuecmd('es_xgive %s env_fog_controller'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogdir %s %s %s\"'%(userid, 0, 0, 0))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogstart %s\"'%(userid, int(sv('fog_start'))))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogend %s\"'%(userid, int(sv('fog_end'))))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogblend 1"'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor %s %s %s\"'%(userid, r, g, b))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 %s %s %s\"'%(userid, r2, g2, b2))
			es.server.queuecmd('es_xfire %s env_fog_controller turnon'%userid)

def knife_bot():
	es.server.queuecmd('bot_knives_only 1')
	es.server.queuecmd('bot_join_after_player 0')
	es.server.queuecmd('bot_join_team t')
	es.server.queuecmd('mp_limitteams 0;mp_autoteambalance 0')

def add_bots():
	bots = int(sv('zombie_bots'))
	while bots > 0:
		es.server.queuecmd('bot_add_t')
		bots -= 1
	change_teams()

def kick_bots():
	es.server.queuecmd('bot_kick')

def change_teams():
	for userid in es.getUseridList():
		Player(userid).check_team()

### Returns ###

def random_value(low, high):
	return random.randint(int(low * 1000), int(high * 1000)) / 1000.0

### Loops ###

def update_hud():
	for userid in es.getUseridList():
		Player(userid).hud()
	gamethread.delayedname(float(sv('hud_update_time')), 'update_hud', update_hud)

update_hud()



